let _trackId;export function createRenderingContext(canvas){const actualContext=canvas.getContext("2d");if(!actualContext){throw new TypeError("Unable to create 2d context")}const transformStack=[actualContext.getTransform()];const saveStack=[actualContext.getTransform()];const getCurrentTransform=()=>transformStack[transformStack.length-1];const isInPath=(path,transform,x,y,config)=>{actualContext.save();actualContext.setTransform(transform);const include=config?.include??"fill";let result=false;if(include==="all"||include==="fill"){result=result||actualContext.isPointInPath(path,x,y)}if(include==="all"||include==="stroke"){actualContext.lineWidth=config?.lineWidth??0;result=result||actualContext.isPointInStroke(path,x,y)}actualContext.restore();return result};const clickHandlers=[];const dblclickHandlers=[];const contextMenuHandlers=[];const mouseOverHandlers=[];const mouseOutHandlers=[];const mouseMoveHandlers=[];const clearEventRegistry=()=>{clickHandlers.length=0;dblclickHandlers.length=0;contextMenuHandlers.length=0;mouseOverHandlers.length=0;mouseOutHandlers.length=0;mouseMoveHandlers.length=0};const onClick=(path,handler,config)=>{clickHandlers.push({path,transform:getCurrentTransform(),handler,config})};const onDblClick=(path,handler,config)=>{dblclickHandlers.push({path,transform:getCurrentTransform(),handler,config})};const onContextMenu=(path,handler,config)=>{contextMenuHandlers.push({path,transform:getCurrentTransform(),handler,config})};const onMouseOver=(path,handler,config)=>{mouseOverHandlers.push({path,transform:getCurrentTransform(),handler,config})};const onMouseOut=(path,handler,config)=>{mouseOutHandlers.push({path,transform:getCurrentTransform(),handler,config})};const onMouseMove=(path,handler,config)=>{mouseMoveHandlers.push({path,transform:getCurrentTransform(),handler,config})};const eventRegistry={onClick,onDblClick,onContextMenu,onMouseOver,onMouseOut,onMouseMove};const ac=new AbortController;const subscription={unsubscribe(){if(!ac.signal.aborted){clearEventRegistry();ac.abort()}}};canvas.addEventListener("click",e=>{const[x,y]=getMousePosition(e);for(const{path,transform,handler,config}of clickHandlers){if(isInPath(path,transform,x,y,config)){try{handler(e)}catch(err){reportError(err)}}}},{signal:ac.signal});canvas.addEventListener("dblclick",e=>{const[x,y]=getMousePosition(e);for(const{path,transform,handler,config}of dblclickHandlers){if(isInPath(path,transform,x,y,config)){try{handler(e)}catch(err){reportError(err)}}}},{signal:ac.signal});canvas.addEventListener("contextmenu",e=>{const[x,y]=getMousePosition(e);for(const{path,transform,handler,config}of contextMenuHandlers){if(isInPath(path,transform,x,y,config)){try{handler(e)}catch(err){reportError(err)}}}},{signal:ac.signal});const trackedMouseOutPaths=new Set;const trackedMouseOverPaths=new Set;let maybeDelete=new Set;const beginRender=()=>{clearEventRegistry();maybeDelete=new Set([...trackedMouseOutPaths,...trackedMouseOverPaths]);_trackId=id=>{maybeDelete.delete(id)}};const endRender=()=>{for(const id of maybeDelete){trackedMouseOutPaths.delete(id);trackedMouseOverPaths.delete(id)}};canvas.addEventListener("mousemove",e=>{const[x,y]=getMousePosition(e);for(const{path,transform,handler,config}of mouseMoveHandlers){if(isInPath(path,transform,x,y,config)){try{handler(e)}catch(err){reportError(err)}}}for(const{path:path1,transform:transform1,handler:handler1,config:config1}of mouseOutHandlers){if(isInPath(path1,transform1,x,y,config1)){trackedMouseOutPaths.add(config1.id)}else if(trackedMouseOutPaths.has(config1.id)){trackedMouseOutPaths.delete(config1.id);try{handler1(e)}catch(err1){reportError(err1)}}}for(const{path:path2,transform:transform2,handler:handler2,config:config2}of mouseOverHandlers){if(isInPath(path2,transform2,x,y,config2)){trackedMouseOverPaths.delete(config2.id);try{handler2(e)}catch(err2){reportError(err2)}}else if(trackedMouseOverPaths.has(config2.id)){trackedMouseOverPaths.add(config2.id)}}});const renderContext=new Proxy(actualContext,{set(target,prop,reciever){return Reflect.set(target,prop,reciever)},get(target,prop){switch(prop){case"rotate":case"translate":case"scale":case"transform":case"setTransform":return(...args)=>{const result=target[prop](...args);transformStack.push(target.getTransform());return result};case"save":return()=>{const result=target[prop]();saveStack.push(transformStack[transformStack.length-1]);return result};case"restore":return function(){const result=target[prop]();const jumpTo=saveStack.pop();while(transformStack[transformStack.length-1]!==jumpTo){transformStack.pop()}return result};case"resetTransform":return()=>{const result=target[prop]();transformStack.length=1;saveStack.length=1;return result}}const result=target[prop];if(typeof result==="function"){return(...args)=>target[prop](...args)}return result}});return{renderContext,eventRegistry,subscription,beginRender,endRender}}export function createRenderer(canvas){const{renderContext:ctx,eventRegistry,subscription,beginRender,endRender}=createRenderingContext(canvas);const render=comp=>{beginRender();ctx.save();ctx.clearRect(0,0,canvas.width,canvas.height);_trackId("#root");comp(ctx,eventRegistry,"#root");ctx.restore();endRender()};return{render,remove(){subscription.unsubscribe()}}}export function getMousePosition(e){const bounds=e.target.getBoundingClientRect();const x=e.clientX-bounds.left;const y=e.clientY-bounds.top;return[x,y]}function handleCursorStyle(ctx,eventRegistry,path,cursor,eventConfig){const canvas=ctx.canvas;eventRegistry.onMouseOver(path,()=>{canvas.style.cursor=cursor},eventConfig);eventRegistry.onMouseOut(path,()=>{canvas.style.removeProperty("cursor")},eventConfig)}export function rect(props){return(ctx,eventRegistry,parentId)=>{ctx.save();const{x,y,width,height,style,events}=props;const fillStyle=style?.fillStyle;if(fillStyle){ctx.fillStyle=fillStyle;ctx.fillRect(x,y,width,height)}const{strokeStyle,lineWidth}=style??{};if(strokeStyle&&lineWidth){ctx.strokeStyle=strokeStyle;ctx.lineWidth=lineWidth;ctx.strokeRect(x,y,width,height)}const path=new Path2D;path.rect(x,y,width,height);const id=`${parentId}:rect`;_trackId(id);const eventConfig={id,include:"all",lineWidth:style?.lineWidth??0};if(events){manageEvents(events,eventRegistry,path,eventConfig)}if(style?.cursor){handleCursorStyle(ctx,eventRegistry,path,style?.cursor,eventConfig)}ctx.restore()}}function manageEvents(events,eventRegistry,path,config){for(const[eventKey,handler]of Object.entries(events)){eventRegistry[eventKey](path,handler,config)}}export function line(props){return(ctx,eventRegistry,parentId)=>{ctx.save();const{x1,y1,x2,y2,style,hitPadding=5,events}=props;const{lineWidth=1,strokeStyle}=style??{};const path=new Path2D;path.moveTo(x1,y1);path.lineTo(x2,y2);if(strokeStyle){ctx.strokeStyle=strokeStyle;ctx.lineWidth=lineWidth;ctx.stroke(path)}const id=`${parentId}:line`;_trackId(id);const eventConfig={id,include:"all",lineWidth:(style?.lineWidth??0)+hitPadding};if(events){manageEvents(events,eventRegistry,path,eventConfig)}if(style?.cursor){handleCursorStyle(ctx,eventRegistry,path,style.cursor,eventConfig)}ctx.restore()}}export function verticalLine(props){return(ctx,eventRegistry,parentId)=>{const{x,y1=0,y2=ctx.canvas.height,...rest}=props;return line({...rest,x1:x,x2:x,y1,y2})(ctx,eventRegistry,parentId)}}export function horizontalLine(props){return(ctx,eventRegistry,parentId)=>{const{y,x1=0,x2=ctx.canvas.width,...rest}=props;return line({...rest,x1,x2,y1:y,y2:y})(ctx,eventRegistry,parentId)}}export function img(props){return(ctx,eventRegistry,parentId)=>{ctx.save();const{img,x,y,width=img.width,height=img.height,style,events}=props;ctx.drawImage(img,x,y,width,height);const{lineWidth,strokeStyle}=style??{};if(lineWidth&&strokeStyle){ctx.strokeStyle=strokeStyle;ctx.lineWidth=lineWidth;ctx.strokeRect(x,y,width,height)}const path=new Path2D;path.rect(x,y,width,height);const id=`${parentId}:img`;_trackId(id);const eventConfig={id,include:lineWidth?"all":"fill",lineWidth:lineWidth};if(events){manageEvents(events,eventRegistry,path,eventConfig)}if(style?.cursor){handleCursorStyle(ctx,eventRegistry,path,style.cursor,eventConfig)}ctx.restore()}}export function group(children){return(ctx,eventRegistry,parentId)=>{for(let i=0;i<children.length;i++){const child=children[i];ctx.save();const id=`${parentId}:${i}`;_trackId(id);child(ctx,eventRegistry,id);ctx.restore()}}}export function scale(scale,renderer){return(ctx,eventRegistry,parentId)=>{ctx.save();const[x,y]=Array.isArray(scale)?scale:[scale,scale];ctx.scale(x,y);const id=`${parentId}:scale`;_trackId(id);renderer(ctx,eventRegistry,id);ctx.restore()}}export function translate(x,y,renderer){return(ctx,eventRegistry,parentId)=>{ctx.save();ctx.translate(x,y);const id=`${parentId}:translate`;_trackId(id);renderer(ctx,eventRegistry,id);ctx.restore()}}export function rotate(angle,renderer){return(ctx,eventRegistry,parentId)=>{ctx.save();ctx.rotate(angle);const id=`${parentId}:rotate`;_trackId(id);renderer(ctx,eventRegistry,id);ctx.restore()}}export function transform(matrix,renderer){return(ctx,eventRegistry,parentId)=>{ctx.save();ctx.setTransform(matrix);renderer(ctx,eventRegistry,`${parentId}:${matrix}`);ctx.restore()}}export function clipRect(rect,renderer){const path=new Path2D;path.rect(rect.x,rect.y,rect.width,rect.height);return clip(path,renderer)}export function clip(path,renderer){return(ctx,eventRegistry,parentId)=>{ctx.save();ctx.clip(path);const id=parentId+":clip";_trackId(id);renderer(ctx,eventRegistry,id);ctx.restore()}}export function text(props){return(ctx,eventRegistry,parentId)=>{ctx.save();const{x,y,style,events}=props;const{strokeStyle,fillStyle,lineWidth,textAlign,textBaseline,font,maxWidth=Infinity,maxHeight=Infinity,lineHeight=20,overflow,wordWrap=false}=style;ctx.font=font??"13px sans-serif";ctx.textBaseline=textBaseline??"top";ctx.textAlign=textAlign??"left";const renderText=(txt,y)=>{if(strokeStyle&&lineWidth){ctx.strokeStyle=strokeStyle;ctx.lineWidth=lineWidth;ctx.strokeText(txt,x,y,maxWidth)}if(fillStyle){ctx.fillStyle=fillStyle;ctx.fillText(txt,x,y,maxWidth)}};let textWidth=0;let textHeight=0;if(wordWrap){const words=props.text.split(" ");let line="";let lineCount=0;while(words.length){if(maxHeight<y+lineCount*lineHeight+lineHeight){const remaining=words.join(" ");const lastLine=overflow==="ellipsis"&&maxWidth?getEllipsisText(ctx,remaining,maxWidth):remaining;renderText(lastLine,y+lineCount*lineHeight)}else{if(maxWidth<ctx.measureText(line+words[0]).width){const bounds=ctx.measureText(line);textWidth=Math.max(bounds.width);textHeight=lineCount*lineHeight+bounds.actualBoundingBoxDescent-bounds.actualBoundingBoxAscent;renderText(line,y+lineCount*lineHeight);line="";lineCount++}line+=words.shift()+" "}}}else{const text=overflow==="ellipsis"&&maxWidth?getEllipsisText(ctx,props.text,maxWidth):props.text;renderText(text,y);const bounds1=ctx.measureText(text);textWidth=bounds1.width;textHeight=bounds1.actualBoundingBoxDescent-bounds1.actualBoundingBoxAscent}if(events||style.cursor){const id=`${parentId}:text`;_trackId(id);const path=new Path2D;path.rect(x,y,textWidth,textHeight);const eventConfig={id,include:lineWidth?"all":"fill",lineWidth:lineWidth};if(events){manageEvents(events,eventRegistry,path,eventConfig)}if(style.cursor){handleCursorStyle(ctx,eventRegistry,path,style.cursor,eventConfig)}}ctx.restore()}}function getEllipsisText(renderContext,text,maxWidth){const metrics=renderContext.measureText(text);if(metrics.width<maxWidth){return text}let low=-1;let high=text.length;while(1+low<high){const mid=low+(high-low>>1);if(isTextTooWide(renderContext,text.substring(0,mid)+"...",maxWidth)){high=mid}else{low=mid}}const properLength=high-1;return text.substring(0,properLength)+"..."}function isTextTooWide(renderContext,text,maxWidth){const metrics=renderContext.measureText(text);return maxWidth<metrics.width}
//# sourceMappingURL=index.js.map